use proc_macro2::{Ident, TokenStream};
use quote::quote;

use crate::types::RwSpecifier;

pub(super) fn gen_registerspec_impl(
    reg_name: Ident,
    modf: RwSpecifier,
    type_t: Ident,
    type_ux: Ident,
) -> TokenStream {
    let impl_rw = match modf {
        RwSpecifier::R => quote! {
            impl<T: AxiC2c1Spec> Readable for #reg_name<'_, T> {}
        },
        RwSpecifier::W => quote! {
            impl<T: AxiC2c1Spec> Writable for #reg_name<'_, T> {}
        },
        RwSpecifier::RW => quote! {
            impl<T: AxiC2c1Spec> Readable for #reg_name<'_, T> {}
            impl<T: AxiC2c1Spec> Writable for #reg_name<'_, T> {}
            impl<T: AxiC2c1Spec> Modifiable for #reg_name<'_, T> {}
        },
    };
    quote! {
        impl<T: AxiC2c1Spec> RegisterSpec for #reg_name<'_, T> {
            type Ux = #type_ux;
            type T = #type_t;

            fn as_ptr(&self) -> *mut Self::Ux {
                self.mem_ptr
            }
        }
        #impl_rw
    }
}
